import java.awt.event.*;

public class Input implements ActionListener{
	
private InputFenster 	f;
	
public static String 	input_ergebnis; 	// die getaetigte Eingabe
public static String	varname;			// Name der Eingabevariablen
public static int 		string_laenge;		// Zeichenkettenlaenge zur
											// Positionierung innerhalb der
											// Programmzeile
public static int		z_zaehler;			// Zaehler zur Kennzeichnung 
											// der Programmzeile
public static int		i;					// Laufvariable
public static int		anzahl_e;			// Anzahl der "`e"'s in der 
											// Eingabezeichenkette

static Anzeige anzeige;
	
	public Input(InputFenster f, Anzeige anzeige){ 

	this.f  		= f;
	this.anzeige	= anzeige;
	
	input_ergebnis	= "";
	varname 		= "";
	anzahl_e		= 0;
	}

	public void actionPerformed(ActionEvent ae){
	
	/*
	*	Eingabetext holen
	*/
	
		input_ergebnis = InputFenster.eingabe.getText();
		
	/*
	*	Test auf Korrektheit der Eingabe
	*
	*	- Strings kann alles zugewiesen werden
	*	- numerische Variablen duerfen bis auf das "e" keine Buchstaben
	*	  enthalten
	*
	*	-> also: Test ob es eine Stringvariable ist (endet mit $)
	*		ja  	-> alles egal
	*		nein	-> Test auf zulaessige Zeichen,
	*					es duerfen nur Ziffern und 
	*					das "e" bzw. "E"  einmal vorkommen
	*/	
	
	if (!varname.endsWith("$")){
	
		for (i=0;i<input_ergebnis.length();i++){
	
			switch (input_ergebnis.charAt(i)){
	
			case '1': case '2': case '3': case '4': case '5': case '6': case '7': 
			case '8': case '9': case '0': case '.':
					
					break;
					
			case 'e': case 'E':
			
					anzahl_e++;
					
					/*
					*	es darf nur ein "e" in String vorkommen
					*	zur Kennzeichnung des Exponenten
					*/
					
					if (anzahl_e<=1){

						break;

					}
					
			default:
			
			/*
			*	es gab nicht zulaessige Zeichen bzw. Anzahl der e's ist
			*	zu gross;
			*
			*	Programm wird mit der INPUT-Zeile fortgesetzt, so dass
			*	eine erneute Eingabe moeglich ist
			*/	
					anzeige.schreiben(InputFenster.inputtext+" " + input_ergebnis);
					anzeige.schreiben("?REDO FROM START");
		
					Ausfuehren.offset = 0;
					Ausfuehren.z_zaehler=z_zaehler-1;
					Ausfuehren.abbruch = false;
					Ausfuehren.ausgabe=input_ergebnis;
					
					anzahl_e=0; 	// Anzahl der gezaehlten "e"s zuruecksetzen
					
					return;
					
			} // ende switch
		
		} // ende for
		
	} // ende if
	
	/*
	*	Test, ob einen eingegebene numerische Variable auf "e" bzw. "E" endet;
	*
	*	dann ist ein Anfuegen von "0" noetig, um Fehler
	*	bei moeglichem spaeteren Rechnen zu vermeiden
	*/
		
		if (!varname.endsWith("$")
			&&
			(input_ergebnis.endsWith("e")
			||
			input_ergebnis.endsWith("E"))){
			
			input_ergebnis+="0";
		}
		
	/*
	*	befinden wir uns am Ende der aktuellen Programmzeile
	*	
	*	ja  	-> Parameter fuer naechste Zeile modifizieren
	*	nein	-> alles ok
	*/	
		if (string_laenge ==Ausfuehren.teil_string.length()){	
					
			string_laenge=0;
			z_zaehler = z_zaehler+1;
			
		} // ende if
	
	/*
	*	Parameter in Ausfuehren setzen, um Weiterarbeit des Programms 
	*	zu initialisieren
	*/
				
		Ausfuehren.offset = string_laenge;
		Ausfuehren.z_zaehler=z_zaehler;
		Ausfuehren.abbruch = false;
	
	/*
	*	Eingabefenster schlieen
	*/
	
		f.dispose();
	
	/*
	*	Ausgabe des Eingabeaufforderungstextes und der Eingabe
	*/
	
		anzeige.schreiben(InputFenster.inputtext + " " + input_ergebnis);

	/*
	*	eingegebene Variable und ihren Wert in Hashtabelle abspeichern
	*/	
		
		Ausfuehren.vartab.put(varname,input_ergebnis);
	
	/*
	*	Abarbeitung des Programms wieder starten
	*/
		Ausfuehren.losgehts();
	
	}
	
}
